// -*- c++ -*----------------------------------------------
// Title: comm_man
// Project:
// Author:
// Date:

//#include <vector.h>

//#include "envelope.h"
//#include "comm_queue.h"

/*{  Manage the handshake protocol of MPI queues. }*/
class Comm_manager
{
public:
  protocol_manager (Comm&);

  /*{ Place a send request in an outgoing queue }*/
  bool send (MPI::Envelope& r);

  /*{ Place a recv envelope in an outgoing queue }*/
  bool recv (Envelope& r);

  /*{ Wait for the  envelope to complete : send or recv  }*/
  void wait (Envelope& r);

  /*{ Wait for the  any envelope to complete : send or recv  }*/
  void waitAny (int count, Envelope r[]);

  /*{ Wait for the all envelopes to complete : send or recv  }*/
  void waitAll (int count, Envelope r[]);

private:

  Comm_queue **channels;
  int          length;
};

