// -*- c++ -*- ------------------------------------------
// Title: Group
// Author: Kristian Kvilekval
// Project:

#include "mpi.h"


#if 0
void MPI::Group::initialize_group(Group&g, int n, 
				  mpi_int_main mf, 
				  int argc, 
				  char**argv)
{

  DEBUGX(cerr << "Group initialize creating " << n << "tasks " << endl);
  for (int i = 0; i < n; i++)
    {
      MPI::Task *tsk = new MPI::Task (mf, argc, argv);
      tsk->set_rank (i);
      g.tasks.insert (g.tasks.end(), task_ptr (tsk));
      TCB.push_task (tsk);
    }
}
#endif

MPI::Group::Group()
{
}
MPI::Group::~Group()
{
    DEBUGX(cerr << "~Group" << endl);
}
		  

int MPI::Group::Get_size() const
{
  return tasks.size();
}

int MPI::Group::Get_rank() const
{
  MPI::Task *tsk = MPI::Get_current_task();

  //DEBUGX (cerr << "rank = " << tsk->get_rank() << endl);
  return tsk->get_rank();
#if 0
  for (task_set::const_iterator tp = tasks.begin(); tp != tasks.end(); ++tp)
    {
      if (*tp == task_ptr (tsk))
	{
	}
    }
  return -1;
#endif
}




