// -*- c++ -*- ------------------------------------------
// Title: Status
// Author: Kristian Kvilekval
// Project:
#ifndef _Status_H
#define _Status_H

class Status
{
public:
//   Status() {}
//   Status(const Status&rhs) : envelope(rhs.envelope) {}
//   Status& operator=(const Status&rhs) { envelope = rhs.envelope; }
  virtual ~Status() {}

  /////////////////////////////////////////////
  // Point-to-Point Communication
  virtual int Get_count(const Datatype& datatype) const;
  virtual bool Is_cancelled() const;
  virtual int Get_elements(const Datatype& datatype) const;

  ////////////////////////////////////////////
  // Status Access
  virtual int Get_source() const;
  virtual void Set_source(int source);
  virtual int Get_tag() const;
  virtual void Set_tag(int tag);
  virtual int Get_error() const;
  virtual void Set_error(int error);

protected:
  
private:
  friend class Request;
  void set_from_envelope (Envelope& x) { envelope = x; }
  
  Envelope envelope;
};	// end of class Status



#endif  // _Status_H
