// -*- c++ -*- -----------------------------------------------------
//
//
#ifdef _EXCEPTION_H
#define _EXCEPTION_H


class Exception
{
public:
  Exception(); 
  Exception(int ec) { error_code = ec; }
  Exception(const Exception&rhs);
  Exception& operator=(const Exception&rhs);
  ~Exception();			// the destructor

  int Get_error_code() const { return error_code; }
  int Get_error_class() const { return error_class; }
  const char* Get_error_string() const { return error_string; }

protected:
 
  int error_code;
  char* error_string;
  int error_class;
  
private:
  
};	// end of class Exception

#endif /* _EXCEPTION_H */
