// -*- c++ -*- ------------------------------------------
// Title: Op
// Author: Kristian Kvilekval
// Project:
#ifndef _Op_H
#define _Op_H


class Op
{
public:
//   Op();
//   Op(const Op&rhs);
//   Op& operator=(const Op&rhs);
  
//   ~Op();

  //  virtual void Init(User_function *func, bool commute);
  //  virtual void Free();


  virtual void operation (const void*src, void*rcv, 
			  const Datatype&, int count)const ;
protected:
  
  friend class MPI;
  Op (int code) : op_code (code) {}

  enum op_builtin { OP_MAX, OP_MIN, OP_SUM, OP_PROD, OP_MAXLOC,
		    OP_MINLOC, OP_BAND, OP_BOR, OP_BXOR, OP_LAND,
		    OP_LOR, OP_LXOR };

  int op_code;

};	// end of class Op


class Op_max : public Op
{
public:
  friend class MPI;
  Op_max (int code) : Op (code) {}
  void operation (const void*src, void*rcv, const Datatype&, int count)const;
};

class Op_min : public Op
{
public:
  friend class MPI;
  Op_min (int code) : Op (code) {}
  void operation (const void*src, void*rcv, const Datatype&, int count)const;
};

class Op_sum : public Op
{
public:
  friend class MPI;
  Op_sum (int code) : Op (code) {}
  void operation (const void*src, void*rcv, const Datatype&, int count)const;
};

#endif  // _Op_H
